
{$I-}
unit SockUnit;  {Version 1.02 as of 23 July 1992 }

{ BSD 4.0 Socket TCP/IP interface unit }
{ Copyright 1992 Knight Software }
{ First pre-release 23 July 1992 - Mike Day }

{ ************************************************************* }
{ ********* Warning! This unit is NOT fully functional ******** }
{ ********* It still needs lots of work!               ******** }
{ ************************************************************* }

interface

{===================================================}

Type SockAddrType = record
       sa_family : word;	{ address family }
       sa_data   : array[0..13] of char; { up to 14 bytes of address }
     end;
     SockAddrPtr = ^SockAddrType;
     SockLenPtr = ^integer;

Type SockProtoType = record
       sp_family   : word; { address family }
       sp_protocol : word; { protocol }
     end; 
     SockProtoPtr = ^SockProtoType;


{===================================================}
{Socket Manipulation Routines}

function SocketAccept(s:integer; sa:SockAddrPtr; len:SockLenPtr):integer;
function SocketBind(s:integer; Sname:SockAddrPtr; len:integer):integer;
function SocketClose(s:integer):integer;
function SocketConnect(s:integer; Sname:SockAddrPtr; len:integer):integer;
function SocketListen(s:integer; BackLog:integer):integer;
function SocketRecv(s:integer; buf:pointer; len:integer; flags:integer):integer;
function SocketRecvFrom(s:integer; buf:pointer; len:integer; flags:integer;
                         sfrom:SockAddrPtr; sfromlen:SockLenPtr):integer;
function SocketSend(s:integer; buf:pointer; len:integer; flags:integer):integer;
function SocketSendTo(s:integer; buf:pointer; len:integer; flags:integer;
                      sto:SockAddrPtr; stolen:integer):integer;
function SocketShutDown(s,how:integer):integer;
function SocketOpen(af,ts,protocol:integer):integer;  {create a socket}
function SocketRead(s:integer; buf:pointer; len:integer):integer;
function SocketWrite(s:integer; buf:pointer; len:integer):integer;

function SocketSelect(nfds:integer;  {* NI *}
                      readfds,writefds,exceptfds,timeout:pointer):integer;
{procedure Fcntl;       }     {* NI *}
{procedure GetPeerName; }     {* NI *}
{procedure GetSockName; }     {* NI *}
{procedure GetSockOpt;  }     {* NI *}
{procedure SetSockOpt;  }     {* NI *}
{procedure Ioctl;       }     {* NI *}

{===================================================}
{System Resource Control Routines}

{procedure GetHostId;    }     {* NI *}
{procedure SetHostId;    }     {* NI *}
{procedure GetHostName;  }     {* NI *}
{procedure SetHostName;  }     {* NI *}
{procedure GetDomainName;}     {* NI *}
{procedure SetDomainName;}     {* NI *}
{procedure GetLogin;     }     {* NI *}
{procedure Sleep;        }     {* NI *}
{procedure Perror;       }     {* NI *}
{procedure Syslog;       }     {* NI *}
{procedure OpenLog;      }     {* NI *}
{procedure CloseLog;     }     {* NI *}
{procedure SetLogMask;   }     {* NI *}
{procedure GetTimeOfDay; }     {* NI *}

{===================================================}
{Support Routines}

{---------------------------------------------------}
{Byte Ordering}
function Htonl(L:longint):longint; {network longint to PC Longint}
function Htons(W:word):word;       {network word to PC word}
function Ntohl(L:longint):longint; {PC longint to Network Longint}
function Ntohs(W:word):word;       {PC word to Network word}

{---------------------------------------------------}
{Name Translation Services}


type HostEntType = record
       hName     : ^char;
       hAliases  : pointer;
       hAddrType : integer;
       hLength   : integer;
       hAddrList : pointer;
     end;
     HostEntPtr = ^HostEntType;

var he    : HostEntType;
    buf   : array[0..127] of char;
    hptr  : array[0..9] of ^char;
    taddr : array[0..1] of longint;
    tptr  : array[0..1] of pointer;

function GetHostByAddr(IPaddr:pointer; len,ta:integer):HostEntPtr;
function GetHostByName(name:pointer):HostEntPtr;   {get host desc}

{---------------------------------------------------}
{Protocol Entry Routines}
{procedure GetProtoEnt;     }  {* NI *}
{procedure GetProtoByNumber;}  {* NI *}
{procedure GetProtoByName;  }  {* NI *}
{procedure SetProtoEnt;     }  {* NI *}
{procedure EndProtoEnt;     }  {* NI *}

{---------------------------------------------------}
{Service Entry Routines}
{procedure GetServEnt;   }     {* NI *}
{procedure GetServByPort;}     {* NI *}
{procedure GetServByName;}     {* NI *}
{procedure SetServEnt;   }     {* NI *}
{procedure EndServEnt;   }     {* NI *}

{---------------------------------------------------}
{Internet Address Manipulation Routines}
{procedure InetAddr;     }     {* NI *}
{procedure InetNetwork;  }     {* NI *}
{procedure InetNtoa;     }     {* NI *}
{procedure InetMakeAddr; }     {* NI *}
{procedure InetInaof;    }     {* NI *}
{procedure InetNetof;    }     {* NI *}


{ Structure used for manipulating linger option. }
type  Linger = record
	Lonoff  : integer; { option on/off }
	Llinger : integer; { linger time }
      end; 

const ITIMER_TIMEOUT_VALUE : longint = 0;  {when does this get inited? @@@}

{***********************************************************************}

implementation

uses TcpSys,AStub;

{$I SOCKDEF.INC}
{$I ASYNCH.INC}
{$I TCPERR.INC}
{$I ERRNO.INC}
{$I INET.INC}

const SocketInit : integer = 0;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++}

{ Misc internal routines }

  {check if socket number is valid}
  function ValidSocket(s:integer; var sp:SocketPtr):boolean;
  begin
    if (s > MaxSock) or (s < 0) then
    begin
      errno := ENOTSOCK;           { not a valid socket number }
      ValidSocket := false;
      Exit;
    end;
    sp := Sock[s];
    if sp = nil then
    begin
      errno := ENOTSOCK;           { not a valid socket number }
      ValidSocket := false;
      Exit;
    end;
    if sp^.nd = 0 then
    begin
      errno := EBADF;
      ValidSocket := false;
      Exit;
    end;
    if IsNetNd(sp^.nd) <> 0 then
    begin
      errno := ENOTSOCK;
      ValidSocket := false;
      Exit;
    end;
    ValidSocket := true;
  end;


function FillConQ(sp:SocketPtr):integer;
var i, BackLog : integer;
    tc, nc  : NconnPtr;
begin
   BackLog := sp^.MaxQlen;
   nc := sp^.NconnQ;
   for i := 0 to pred(BackLog) do
   begin
     if nc = nil then
     begin
       if MaxAvail < sizeof(NconnType) then
       begin
         FillConQ := ENOBUFS;
         Exit;
       end;
       New(tc);
       tc^.nd := (NetGetDesc * -1);
       if tc^.nd = 1 then
       begin
         dispose(tc);
         FillConQ := EMFILE;
         Exit;
       end;
       nc^.next := tc;
       nc := tc;
     end;
     nc := nc^.next;
   end;
   FillConQ := 0;
end;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++}

{Socket Manipulation Routines}

{-----------------------------------------------------}
{Accept is used in conjunction with Async receiption of data}
{Accept collects the data received for the specd descriptor}
{then requeues it. The Socket must be created with SocketOpen,}
{Bound with Bind, and and placed in listening state by Listen.}
{Possible errors are: EBADF, EFAULT, EINVAL, EMFILE, ENOBUFS, }
{                     ENOTSOCK, EOPNOTSUPP, EWOULDBLOCK }
function SocketAccept(s:integer; sa:SockAddrPtr; len:SockLenPtr):integer;
var sp,nsp : SocketPtr;
    Saip   : SockAddrInetPtr;
    Result : integer;
    wason  : integer;
    nc,ec  : NconnPtr;
    tp     : pointer;
begin
  SocketAccept := -1;
  if not ValidSocket(s,sp) then Exit;
  Saip := SockAddrInetPtr(sa);

  if (sp^.state and SI_MASK) and SI_LISTENING = 0 then
  begin
    errno := EINVAL;      {not listening}
    Exit;
  end;
  if sp^.Stype <> STREAM then   {must be a TCP STREAM type}
  begin
    errno := EOPNOTSUPP;
    Exit;
  end;
  if (Saip <> nil) and (len^ < sizeof(Saip^)) then
  begin
    errno := EFAULT;
    Exit;
  end;

  if sp^.Nconnq = Nil then     {try to refill descriptor queue}
  begin
    Result := FillConQ(sp);
    if sp^.Nconnq <> nil then
    begin
      Result := ReListen(sp);
      if Result <> 0 then
      begin
        errno := Result;
        Exit;
      end;
    end
    else
    begin
      errno := EMFILE;
      Exit;
    end;
  end;

  if sp^.CurQlen  = 0 then
  begin
    if sp^.options and NET_FLG_NONBLOCKING <> 0 then
    begin
      errno := EWOULDBLOCK;
      Exit;
    end;
    if ((sp^.state and SI_MASK) and SI_LISTEN_ERR) <> 0 then
    begin
      Result := ReListen(sp);
      if Result <> 0 then
      begin
        errno := Result;
        Exit;
      end;
    end;
    while sp^.CurQlen = 0 do   {wait for queue to not be zero}
    begin
      {do nothing}   {eek! This is scary. Possible for lockups here}
    end;

    wason := DisableAsynch;

    nc := sp^.Nconnq;
    while (nc <> nil) and (nc^.nd >= 0) do
    begin
      nc := nc^.next;
    end;
    tp := nc;
    nc := sp^.Nconnq;
    sp^.Nconnq := nc^.next;
    dec(sp^.CurQlen);

    Result := FillConQ(sp);

    if wason <> 0 then
      Result := EnableAsynch;

    if MaxAvail < sizeof(nsp^) then
    begin
      Result := NetAbort(nc^.nd);
      Dispose(nc);
      errno := ENOBUFS;
      Exit;
    end;
    new(nsp);
    fillchar(nsp^,sizeof(nsp^),0);

    nsp^.state := SI_CONNECTED or SI_BOUND or SI_OPEN or
                  SI_CAN_SEND or SI_CAN_RECV;
    nsp^.flags := sp^.flags;
    nsp^.options := sp^.options;
    nsp^.af := sp^.af;
    nsp^.stype := sp^.stype;
    nsp^.nd := nc^.nd;
    nsp^.lhost := nc^.lhost;
    nsp^.fhost := nc^.fhost;
    nsp^.fsocket := nc^.fsocket;
    nsp^.lsocket := nc^.lsocket;
    nsp^.protocol := nc^.protocol;
    nsp^.Lintrvl := nc^.Lintrvl;
    dispose(nc);

    if (nsp^.nd < 0) or (sock[nsp^.nd] <> nil) then
    begin
      errno := -1;
      Exit;
    end;

    sock[nsp^.nd] := nsp;

    if Saip <> nil then
    begin
      Saip^.SinFamily := nsp^.af;
      Saip^.SinPort := htons(nsp^.fsocket);
      Saip^.SinAddr.Saddr := nsp^.fhost;
      len^ := sizeof(Saip^);
    end;

    wason := DisableAsynch;
    nc := sp^.Nconnq;
    while (nc <> nil) and (nc^.nd >= 0) do
      nc := nc^.next;

    if (tp = nil) and (nc <> nil)
        and (ReListen(sp) <> 0) then
      sp^.state := sp^.state or SI_LISTEN_ERR;

    if wason <> 0 then
      Result := EnableAsynch;
    SocketAccept := nsp^.nd;
  end;
end;

{-----------------------------------------------------}
{Bind a socket - Used to bind a datagram socket after creating the}
{socket with SocketOpen. Use Connect or Listen to use the socket.}
{Possible Errors are: EADDRINUSE, EAFNOSUPPORT, EBADF, EINVAL, }
{                     ENOBUS, ENOTCONN, ENOTSTOCK }
function SocketBind(s:integer; Sname:SockAddrPtr; len:integer):integer;
var Iname   : SockAddrInetPtr;
    sp      : SocketPtr;
    tsock   : SocketPtr;
    NewPort : word;
    i       : integer;
begin
  SocketBind := -1;
  if not ValidSocket(s,sp) then Exit;

  Iname := SockAddrInetPtr(Sname);
  NewPort := ntohs(Iname^.SinPort);

  if Iname^.SinFamily <> sp^.af then
  begin
    errno := EAFNOSUPPORT;
    Exit;
  end;

  if (((sp^.state and SI_MASK) and SI_BOUND) <> 0)
     or (len <> sizeof(Iname^)) then
  begin
    errno := EINVAL;
    Exit;
  end;

  if Iname^.SinAddr.Snet = 255 then
  begin
    errno := EADDRNOTAVAIL;
    Exit;
  end;

  if (sp^.flags and SO_REUSEADDR) = 0 then
  begin
    for i := 0 to MaxSock do
    begin
      tsock := Sock[i];
      if (tsock <> nil) and (s <> i) and (tsock^.Lsocket = NewPort)
         and (tsock^.stype = sp^.stype) then
      begin
        errno := EADDRINUSE;
        Exit;
      end;
    end;
  end;

  sp^.Fhost := 0;
  sp^.Fsocket := 0;
  sp^.Lsocket := NewPort;
  sp^.Lhost := Iname^.SinAddr.Saddr;

  if sp^.stype = DGRAM then
  begin
    if NetConnect(sp^.nd,sp^.stype,pointer(sp^.Fhost)) = -1 then
    begin
      case neterrno of
        NET_ERR_INUSE : begin
                          errno := EADDRINUSE;
                          Exit;
                        end;

        NET_ERR_NOMEM : begin
                          errno := ENOBUFS;
                          Exit;
                        end;

        NET_ERR_NOTNETCONN : begin
                               errno := ENOTCONN;
                               Exit;
                             end;

        NET_ERR_UNBOUND    : begin
                               errno := EDESTADDRREQ;
                               Exit;
                             end;

        else                 begin
                               errno := -1;
                               Exit;
                             end;
      end;  {case}
    end;
  end;

  sp^.state := sp^.state or SI_BOUND or SI_CAN_SEND or SI_CAN_RECV;
  SocketBind := 0;
end;

{-----------------------------------------------------}
{Close an open socket and discard the descriptor}
{No specific errors returned. 0=success; -1 = close failed}
function SocketClose(s:integer):integer;
var sp : SocketPtr;
    nc : NconnPtr;
    LingerTime : longint;
    Result : integer;
begin
  SocketClose := -1;
  if not ValidSocket(s,sp) then Exit;

  if sp^.flags and SO_LINGER <> 0 then
  begin
    if sp^.state and (SI_LISTENING or SI_CONNECTED) <> 0 then
    begin
      if sp^.Lintrvl = 0 then    {if no linger, just shut it down}
        Result := NetAbort(sp^.nd)
      else                       {else wait for the spec time}
      begin
        LingerTime := sp^.Lintrvl * 1000; {use time in msec}
        Result := SetOption(sp^.nd, STREAM, NET_OPT_TIMEOUT,
                            LingerTime, sizeof(LingerTime));
      end;
    end;
  end;

  sp^.state := 0;
  Result := NetRelease(sp^.nd);

  while nc = sp^.NconnQ do
  begin
    if nc^.nd < 0 then
      nc^.nd := nc^.nd * -1;
    Result := NetAbort(nc^.nd);
    sp^.Nconnq := nc^.next;
    dispose(nc);
  end;

  Dispose(sp);
  Sock[s] := nil;
  SocketClose := 0;
end;

{-----------------------------------------------------}
{Connect a socket for use with datagram Send/Recv/Read/Write,}
{or with Bind/Listen/Accept for a stream connection.}
{Possible errors are: EADDRINUSE, EADDRNOTAVAIL, EAFNOSUPPORT, EBADF, }
{                     ECONNREFUSED, EDESTADDREQ, EFAULT, EINVAL, EISCONN, }
{                     EMFILE, ENETUNREACH, ENOBUFS, ENOTCONN, ENOTSOCK, }
{                     ETIMEDOUT, EWOULDBLOCK }
function SocketConnect(s:integer; Sname:SockAddrPtr; len:integer):integer;
var sp    : SocketPtr;
    Iname : SockAddrInetPtr;
    nd    : integer;
    Result: integer;
begin
  SocketConnect := -1;
  if not ValidSocket(s,sp) then Exit;

  Iname := SockAddrInetPtr(Sname);

  if (Iname = nil) or (len <> sizeof(Iname^)) then
  begin
    errno := EFAULT;
    Exit;
  end;

  if Iname^.SinFamily <> AF_Inet then
  begin
    errno := EAFNOSUPPORT;
    Exit;
  end;

  if (sp^.stype = STREAM) and (Iname^.SinPort = 0) then
  begin
    errno := EISCONN;
    Exit;
  end;

  if ((sp^.state and SI_MASK) and
     not(SI_BOUND or SI_CAN_SEND or SI_CAN_RECV)) <> SI_OPEN then
  begin
     errno := EISCONN;
     Exit;
  end;


   {  SADDR = NetAddrPtr(pointer(sp^.Fhost)) }

  if not(NetAddrPtr(pointer(sp^.Fhost))^.Fhost = Iname^.SinAddr.Saddr) then
  begin
    errno := EADDRNOTAVAIL;
    Exit;
  end;

  sp^.Fsocket := ntohs(Iname^.SinPort);

  if (sp^.stype = DGRAM) and
     ((sp^.state and SI_MASK) and SI_BOUND <> 0) then
  begin
    nd := NetGetDesc;
    if nd = -1 then
    begin
      errno := EMFILE;
      Exit;
    end;

    if NetSwap(sp^.nd, nd) = -1 then
    begin
      errno := -1;
      Exit;
    end;
    Result := NetRelease(nd);
  end;

  if sp^.options and NET_FLG_NONBLOCKING <> 0 then
  begin
    if SetOption(sp^.nd, sp^.stype, NET_OPT_NONBLOCKING, 1, 0) = -1 then
    begin
      errno := -1;
      Exit;
    end;
  end;

  if NetConnect(sp^.nd, sp^.stype, pointer(sp^.fhost)) = -1 then
  begin
    case neterrno of
      NET_ERR_INUSE            : begin
                                   errno := EADDRINUSE;
                                   Exit;
                                 end;

      NET_ERR_NOMEM            : begin
                                   errno := ENOBUFS;
                                   Exit;
                                 end;

      NET_ERR_NOTNETCONN       : begin
                                   errno := ENOTCONN;
                                   Exit;
                                 end;

      NET_ERR_NET_UNREACHABLE  : begin
                                   {do nothing}
                                 end;

      NET_ERR_HOST_UNREACHABLE : begin
                                   errno := ENETUNREACH;
                                   Exit;
                                 end;

      NET_ERR_PROT_UNREACHABLE : begin
                                   {do nothing}
                                 end;

      NET_ERR_PORT_UNREACHABLE : begin
                                   errno := ECONNREFUSED;
                                   Exit;
                                 end;

      NET_ERR_TIMEOUT          : begin
                                   errno := ETIMEDOUT;
                                   Exit;
                                 end;

      NET_ERR_RESET            : begin
                                   errno := ECONNREFUSED;
                                   Exit;
                                 end;

      NET_ERR_WOULD_BLOCK      : begin
                                   errno := EWOULDBLOCK;
                                   Exit;
                                 end;

      NET_ERR_UNBOUND          : begin
                                   errno := EDESTADDRREQ;
                                   Exit;
                                 end;

      else                       begin
                                   errno := -1;
                                   Exit;
                                 end;
    end; {case}
  end;

  sp^.lhost := 0;
  sp^.state := sp^.state or SI_CONNECTED or SI_BOUND or
                 SI_CAN_SEND or SI_CAN_RECV;
  if (sp^.options and NET_FLG_NONBLOCKING) <> 0 then
  begin
    errno := EINPROGRESS;
    Exit;
  end;

  SocketConnect := 0;
end;

{-----------------------------------------------------}
{Put socket into listening passive mode to be used with Accept}
{s=socket opened with SocketOpen and bound with Bind. }
{backlog=max queue length allowed for the connection.}
{Possible errors are: EADDRINUSE, EFAULT, EISCONN, EMFILE,}
{                     ENOBUFS, ENOTSOCK, EOPNOTSUPP}
function SocketListen(s:integer; BackLog:integer):integer;
var sp     : SocketPtr;
    tp,nc  : NconnPtr;
    Result : integer;
    temp   : integer;
begin
  SocketListen := -1;
  if not ValidSocket(s,sp) then Exit;

  if sp^.stype <> STREAM then  {gotta be a stream socket}
  begin
    errno := EOPNOTSUPP;
    Exit;
  end;
  if (sp^.state and SI_MASK) and SI_CONNECTED <> 0 then
  begin
    errno := EISCONN;          {gotta be connected}
    Exit;
  end;

  if BackLog < 1 then      {force backlog to be in range}
    BackLog := 1
  else if backLog > MaxListen then
    BackLog := MaxListen;

  if (sp^.state and SI_MASK) and SI_BOUND = 0 then {if not already bound}
  begin                                            {force a generic bind}
    sp^.state := sp^.state or SI_BOUND;
    sp^.lsocket := 0;
    sp^.lhost := 0;
  end;

  temp := DisableAsynch;
  nc := sp^.NconnQ;
  while (nc <> nil) and (nc^.nd >= 0) do
    nc := nc^.next;
  tp := nc;

  sp^.MaxQlen := BackLog;
  Result := FillConQ(sp);

  if ((sp^.state and SI_MASK) and SI_LISTENING = 0) and (Result <> 0) then
  begin
    if tp = nil then
    begin
      nc := sp^.NconnQ;
      while (nc <> nil) and (nc^.nd >= 0) do
        nc := nc^.next;
      if nc <> nil then
        Result := ReListen(sp);
    end;
  end;

  if Result <> 0 then
  begin
    while nc = sp^.NconnQ do
    begin
      if nc^.nd < 0 then
        nc^.nd := nc^.nd * -1;
      temp := NetRelease(nc^.nd);
      sp^.NconnQ := nc^.next;
      dispose(nc);
    end;
    temp := EnableAsynch;
    errno := Result;
    Exit;
  end;

  temp := EnableAsynch;
  if tp = nil then
    sp^.state := sp^.state or SI_LISTENING;

  SocketListen := 0;
end;

{-----------------------------------------------------}
{recv data from a socket. s=socket descriptor, buf=buffer to put data in}
{len=length of the buffer, flags=flags to control the receiving}
{Possible Errors Are: ENETRESET, ENOTCONN, ENOTSOCK, EOPNOTSUPP,
{                     ESHUTDOWN, EWOULDBLOCK }
function SocketRecv(s:integer; buf:pointer; len:integer; flags:integer):integer;
var  stev : longint;
    iflags: word;
       sp : SocketPtr;
        n : integer;
    Result: integer;
begin
   SocketRecv := -1;
   if not ValidSocket(s,sp) then Exit; {socket must be allocated & assigned }

   if ((sp^.stype = STREAM) and      { if type STREAM, must be connected }
      (((sp^.state and SI_MASK) and SI_CONNECTED) = 0)) then
   begin
     errno := ENOTCONN;              { Error: this socket isn't connected }
     Exit;
   end;

   if ((sp^.state and SI_MASK) and SI_CAN_RECV) = 0 then { ready to recv? }
   begin
     SocketRecv := 0;                             { return zero to indicate EOF }
     Exit;
   end;

      { convert from 4bsd flags to tcp flags and check for validity }
      iflags := sp^.options;
      if (flags and MSG_OOB) <> 0 then
      begin
        if sp^.stype = STREAM then
          iflags := iflags or NET_FLG_OOB
        else
        begin
          errno := EOPNOTSUPP;
          Exit;
        end;
      end;

      if (flags and MSG_PEEK) <> 0 then
      begin
        iflags := iflags or NET_FLG_PEEK;
        iflags := iflags and not(NET_FLG_NONBLOCKING);
      end;

   if ITIMER_TIMEOUT_VALUE <> 0 then
   begin
     stev := ITIMER_TIMEOUT_VALUE * 1000;
     Result := SetOption(sp^.nd,DGRAM,NET_OPT_TIMEOUT,stev,sizeof(longint));
   end;

   n := NetRead(sp^.nd,buf,len,nil,iflags);
   if n = -1 then
   begin
     case neterrno of
       NET_ERR_ICMPMSG    : begin
                              {nothing declared}
                            end;
       NET_ERR_RESET      : begin
                              errno := ENETRESET;
                              Exit;
                            end;
       NET_ERR_WOULD_BLOCK: begin
                              errno := EWOULDBLOCK;
                              Exit;
                            end;
       NET_ERR_NOTESTAB   : begin
                              errno := ENOTCONN;
                              Exit;
                            end;
       NET_ERR_EOF        : begin
                              N := 0;
                            end;
       NET_ERR_TIMEOUT    : begin
                              errno := EINTR;
                              Exit;
                            end;
       NET_ERR_HOST_UNREACHABLE: begin
                              errno := EHOSTUNREACH;
                              Exit;
                            end;
       else                 begin
                              errno := -1;
                              Exit;
                            end;
     end; {case}

     SocketRecv := n;
   end;

end;

{-----------------------------------------------------}
{Receive data from the specified socket and address}
{Used on a socket which has been created with SocketOpen, and bound with Bind}
{Possible errors are: EFAULT, EINVAL, ENETRESET, ENOTCONN, ENOTSOCK,}
{                     EOPNOTSUPP, ESHUTDOWN, EWOULDBLOCK}
function SocketRecvFrom(s:integer; buf:pointer; len:integer; flags:integer;
                         sfrom:SockAddrPtr; sfromlen:SockLenPtr):integer;
var sp : SocketPtr;
    na : SocketRecType;
    ts : SockAddrInetPtr;
    temp : integer;
    Result : integer;
    iflags : word;
    stev : longint;
begin
   SocketRecvFrom := -1;
   if not ValidSocket(s,sp) then Exit; {socket must be allocated & assigned}

   if (sp^.state and SI_MASK) and SI_BOUND = 0 then
   begin
     errno := EINVAL;              { Error: this socket isn't bound}
     Exit;
   end;

   if ((sp^.state and SI_MASK) and SI_CAN_RECV) = 0 then { ready to recv? }
   begin
     SocketRecvFrom := 0;                             { return zero to indicate EOF }
     Exit;
   end;

      { convert from 4bsd flags to tcp flags and check for validity }
      iflags := sp^.options;
      if (flags and MSG_OOB) <> 0 then
      begin
        if sp^.stype = STREAM then
          iflags := iflags or NET_FLG_OOB
        else
        begin
          errno := EOPNOTSUPP;
          Exit;
        end;
      end;

      if (flags and MSG_PEEK) <> 0 then
      begin
        iflags := iflags or NET_FLG_PEEK;
        iflags := iflags and not(NET_FLG_NONBLOCKING);
      end;

   if ITIMER_TIMEOUT_VALUE <> 0 then
   begin
     stev := ITIMER_TIMEOUT_VALUE * 1000;
     temp := SetOption(sp^.nd,DGRAM,NET_OPT_TIMEOUT,stev,sizeof(longint));
   end;

   Result := NetRead(sp^.nd, buf, len, @na, iflags);
   if Result = -1 then
   begin
     case neterrno of
       NET_ERR_ICMPMSG         : begin
                                   {no nothing}
                                 end;
       NET_ERR_RESET           : begin
                                   errno := ENETRESET;
                                   Exit;
                                 end;
       NET_ERR_NOTESTAB        : begin
                                   errno := ENOTCONN;
                                   Exit;
                                 end;
       NET_ERR_WOULD_BLOCK     : begin
                                   errno := EWOULDBLOCK;
                                   Exit;
                                 end;
       NET_ERR_EOF             : begin
                                   Result := 0;
                                 end;
       NET_ERR_TIMEOUT         : begin
                                   errno := EINTR;
                                   Exit;
                                 end;
       NET_ERR_HOST_UNREACHABLE: begin
                                   errno := EHOSTUNREACH;
                                   Exit;
                                 end;
       else                      begin
                                   errno := -1;
                                   Exit;
                                 end;
     end; {case}
   end;

   if ITIMER_TIMEOUT_VALUE <> 0 then
   begin
     temp := SetOption(sp^.nd,DGRAM,NET_OPT_TIMEOUT,0,sizeof(longint));
   end;

   ts := SockAddrInetPtr(sfrom);
   if ts <> nil then
   begin
     ts^.SinFamily := AF_INET;
     ts^.SinPort := htons(na.fsocket);
     ts^.SinAddr.Saddr := na.fhost;
     sfromlen^ := sizeof(ts^);
   end;

   SocketRecvFrom := Result;
end;


{-----------------------------------------------------}
{Test descriptors for valid operation}
{nfds=number of descriptors to check}
{readfds=pointer to read condition mask}
{writefds=pointer to write condition mask}
{exceptfds=pointer to exception mask}
{timeout=time to wait for selection to complete}
{Possible errors are: EBADF, EINVAL }
function SocketSelect(nfds:integer;
                      readfds,writefds,exceptfds,timeout:pointer):integer;
begin
  writeln('*NI*');                 { <---- need to implement this yet --}
end;

{-----------------------------------------------------}
{send data to a socket. s=socket descriptor, buf=buffer to put data in}
{len=length of the buffer, flags=flags to control the receiving}
{Possible Errors Are: EACCESS, EFAULT, ENETRESET, ENOBUFS, ENOTCONN, }
{                     ENOTSOCK, EOPNOTSUPP, ESHUTDOWN, EWOULDBLOCK }
function SocketSend(s:integer; buf:pointer; len:integer; flags:integer):integer;
var iflags: word;
     mask : word;
       sp : SocketPtr;
        n : integer;
begin
   SocketSend := -1;
   if not ValidSocket(s,sp) then Exit;

   if (((sp^.state and SI_MASK) and SI_CONNECTED) = 0) then
   begin
     errno := ENOTCONN;  {this socket isn't connected}
     Exit;
   end;

   if ((sp^.state and SI_MASK) and SI_CAN_SEND) = 0 then
   begin
     errno := ESHUTDOWN;
     Exit;
   end;

   if len < 0 then
   begin
     errno := EINVAL;
     Exit;
   end;


     {convert flags from 4bsd here}
     {This sucks, but it is the way they did it}
     {it probably should be cleaned up someday when we have the time}
     mask := 1;
     iflags := 0;
     while (flags and mask) <> 0 do
     begin
       case (mask and flags) of
         0             : begin
                           {do nothing}
                         end;

         MSG_OOB       : begin
                           if sp^.stype <> STREAM then
                           begin
                             errno := EOPNOTSUPP;
                             Exit;
                           end;
                           iflags := iflags or NET_FLG_OOB;
                         end;

         MSG_DONTROUTE : begin
                           iflags := iflags or NET_FLG_DONTROUTE;
                         end;

         else            begin
                      {    writeln('send: Discarding option',mask and flags);}
                         end;
       end; {case (mask and flags)}

       flags := flags xor mask;
       mask := mask shl 1;
     end;

   flags := iflags or sp^.options;
   if (sp^.flags and SO_BROADCAST) <> 0 then
   begin
     flags := flags or NET_FLG_BROADCAST;
   end;



   n := NetWrite(sp^.nd,buf,len,iflags);
   if n = -1 then
   begin
     case neterrno of
       NET_ERR_EOF        : begin
                              errno := ESHUTDOWN;
                              Exit;
                            end;
       NET_ERR_RESET      : begin
                              errno := ENETRESET;
                              Exit;
                            end;
       NET_ERR_WOULD_BLOCK: begin
                              errno := EWOULDBLOCK;
                              Exit;
                            end;
       NET_ERR_NOTESTAB   : begin
                              errno := ENOTCONN;
                              Exit;
                            end;
       NET_ERR_NOMEM      : begin
                              errno := ENOBUFS;
                              Exit;
                            end;
       else                 begin
                              errno := -1;
                              Exit;
                            end;
     end; {case}

     if (sp^.stype = DGRAM) and (n <> len) then
     begin
       errno := EMSGSIZE;
       Exit;
     end;

     SocketSend := n;
   end;

end;

{-----------------------------------------------------}
{Send data to the specified socket and address}
{Used on a socket which has been created with SocketOpen, and bound with Bind}
{Possible errors are: EAFNOSUPPORT, EFAULT, EINVAL, EISCONN, ENOTSOCK,}
{                     ESHUTDOWN, EWOULDBLOCK}
function SocketSendTo(s:integer; buf:pointer; len:integer; flags:integer;
                      sto:SockAddrPtr; stolen:integer):integer;
var sp : SocketPtr;
    na : SocketRecType;
    ts : SockAddrInetPtr;
    mask : word;
    iflags : word;
    Result : integer;
begin
   SocketSendTo := -1;
   if not ValidSocket(s,sp) then Exit;

   if sp^.stype = STREAM then
   begin
     SocketSendTo := SocketSend(s,buf,len,flags);
     Exit;
   end;

   if (((sp^.state and SI_MASK) and SI_BOUND) = 0) then
   begin
     errno := EINVAL;
     Exit;
   end;
   if ((sp^.state and SI_MASK) and SI_CAN_SEND) = 0 then
   begin
     errno := ESHUTDOWN;
     Exit;
   end;
   if len < 0 then
   begin
     errno := EINVAL;
     Exit;
   end;

     {convert flags from 4bsd here}
     {This sucks, but it is the way they did it}
     {it probably should be cleaned up someday when we have the time}
     mask := 1;
     iflags := 0;
     while (flags and mask) <> 0 do
     begin
       case (mask and flags) of
         0             : begin
                           {do nothing}
                         end;

         MSG_OOB       : begin
                           if sp^.stype <> STREAM then
                           begin
                             errno := EOPNOTSUPP;
                             Exit;
                           end;
                           iflags := iflags or NET_FLG_OOB;
                         end;

         MSG_DONTROUTE : begin
                           iflags := iflags or NET_FLG_DONTROUTE;
                         end;

         else            begin
                      {    writeln('send: Discarding option',mask and flags);}
                         end;
       end; {case (mask and flags)}

       flags := flags xor mask;
       mask := mask shl 1;
     end;

   flags := iflags or sp^.options;

   ts := SockAddrInetPtr(sto);
   na.protocol := sp^.protocol;
   if stolen <> sizeof(sto^) then
   begin
    if sto = nil then
    begin
      if (sp^.state and SI_MASK) and SI_CONNECTED = 0 then
      begin
        errno := ENOTCONN;
        Exit;
      end;
      na.fhost := 0;
      na.fsocket := 0;
      na.lsocket := 0;
    end
    else
    begin
      errno := EFAULT;
      Exit;
    end;
   end
   else
   begin
     if ts^.SinFamily <> AF_INET then
     begin
       errno := EAFNOSUPPORT;
       Exit;
     end;
     if (sp^.state and SI_MASK) and SI_CONNECTED <> 0 then
     begin
       errno := EISCONN;
       Exit;
     end;

     na.fhost := ts^.SinAddr.Saddr;
     na.fsocket := ntohs(ts^.SinPort);
     na.lsocket := sp^.lsocket;
   end;

   if sp^.flags and SO_BROADCAST <> 0 then
     flags := flags or NET_FLG_BROADCAST;

   Result := NetWriteTo(sp^.nd,buf,len,@na,flags);
   if Result = -1 then
   begin
     case neterrno of
       NET_ERR_EOF   : begin
                         errno := ESHUTDOWN;
                         Exit;
                       end;
       NET_ERR_NOHOST: begin
                         errno := EADDRNOTAVAIL;
                         Exit;
                       end;
       else            begin
                         errno := -1;
                         Exit;
                       end;
     end; {case}
   end;

   if Result <> len then
   begin
     errno := EMSGSIZE;
     Exit;
   end;

   SocketSendTo := Result;
end;


{-----------------------------------------------------}
{Shut down a socket. s=socket to shutdown. how=how to shut it down}
{Possible errors are: EINVAL, ENOTCONN, ENOTSOCK }
function SocketShutDown(s,how:integer):integer;
var sp : SocketPtr;
    Result : integer;
begin
  SocketShutDown := -1;
  if not ValidSocket(s,sp) then Exit;

  case how of
    0: begin
         sp^.state := sp^.state and not(SI_CAN_RECV);
       end;

    1: begin
         sp^.state := sp^.state and not(SI_CAN_RECV);
         if (sp^.stype = STREAM) and (sp^.state and SI_CONNECTED <> 0) then
           Result := NetEof(sp^.nd);
         sp^.state := sp^.state and not(SI_CAN_SEND);
       end;

    2: begin
         sp^.state := sp^.state and not(SI_CAN_RECV);
         if (sp^.stype = STREAM) and (sp^.state and SI_CONNECTED <> 0) then
           Result := NetEof(sp^.nd);
         sp^.state := sp^.state and not(SI_CAN_SEND);
       end;

  else begin
         errno := EINVAL;
         Exit;
       end;
  end; {case how}

  SocketShutDown := 0;
end;

{-----------------------------------------------------}
{Create a network descriptor and bind attributes to it}
{af=addrerss format (must be PF_INET), ts=socket type }
{SOCK_STREAM, SOCK_DGRAM, SOCK_RAW are the types available}
{protocol=protocol to use with the socket.}
{Returns -1 on error with error number in 'errno'}
{Possible Errors Are: EAFNOSUPPORT, EMFILE, ENFILE, ENOBUFS, }
{                     EPROTONOSUPPORT, EPROTOTYPE, ESOCKTNOSUPPORT }

function SocketOpen(af,ts,protocol:integer):integer;
var     i : integer;
    Stype : integer;
    deflt : integer;
       nd : integer;
       sp : SocketPtr;
begin
   SocketOpen := -1;
   if SocketInit = 0 then
   begin
    inc(SocketInit);          {if socket array not intialized}
    for i := 0 to MaxSock do  {make sure it is cleared to nils}
      Sock[i] := nil;
   end;

   {check for valid address format - currently only AF_Inet allowed}
   if af <> AF_Inet then
   begin
     errno := EAFNOSUPPORT;  {invalid address type}
     Exit;
   end;

   {setup the socket type info}
   case ts of
     SOCK_STREAM : begin
                     Stype := STREAM;
                     deflt := IPPROTO_TCP;
                   end;

     SOCK_DGRAM  : begin
                     Stype := DGRAM;
                     deflt := IPPROTO_UDP;
                   end;

     SOCK_RAW    : begin
                     Stype := RAW_NET;
                     deflt := IPPROTO_RAW;
                   end;
   else begin
          errno := ESOCKTNOSUPPORT;  {invalid socket type}
          Exit;
        end;
   end; {case}

   {setup the protocol type info}
   if protocol <> deflt then
   begin
     if protocol <> 0 then
     begin
       errno := EPROTOTYPE;  {invalid prototype}
       Exit;
     end
     else
     begin
       protocol := deflt;
     end;
   end;

   nd := NetGetDesc;  {get a descriptor from TcpSys}
   if nd = -1 then
   begin
     errno := EMFILE;  {no descriptors available}
     Exit;
   end;
   if nd > MaxSock then  {descriptor overrange?}
   begin
     errno := ENOTSOCK;
     Exit;
   end;

   if Sock[nd] <> nil then
   begin
     errno := -1;
     Exit;
   end;

   if MaxAvail < sizeof(sp^) then  {try to allocate socket on the heap}
   begin
     errno := ENOBUFS;
     Exit;
   end;
   new(sp);
   fillchar(sp^,sizeof(sp^),0);  {now init the socket}
   sp^.state := SI_OPEN;
   sp^.flags := SO_DONTLINGER;
   sp^.af := af;
   sp^.stype := Stype;
   sp^.protocol := protocol;
   sp^.nd := nd;
   sp^.cd := -1;
   Sock[nd] := sp;

   SocketOpen := nd;
end;


{-----------------------------------------------------}
{Read data from a socket}
{s=socket opened with OpenSocket, bound to an address with SocketBind,}
{and connected with Connect. Returns -1 on error, or zero on success}
{see errno for the error type.}
{Possible Errors Are: ENOTCONN, ENOTSOCK, ESHUTDOWN, EWOULDBLOCK }
function SocketRead(s:integer; buf:pointer; len:integer):integer;
begin
  SocketRead := SocketRecv(s,buf,len,0);
end;


{-----------------------------------------------------}
{write data to a socket}
function SocketWrite(s:integer; buf:pointer; len:integer):integer;
var    sp : SocketPtr;
    flags : integer;
begin
  SocketWrite := -1;
  if not ValidSocket(s,sp) then Exit;
  flags := 0;

  if (sp^.stype <> STREAM) and (sp^.fhost = INADDR_ANY) then
    flags := flags or NET_FLG_BROADCAST;
  SocketWrite := SocketSend(s,buf,len,flags);
end;

{===================================================}
{System Resource Control Routines}

{ - none implemented - }


{===================================================}
{Support Routines}

{---------------------------------------------------}
{Byte Ordering}

{Convert Pascal longint to network longint}
function Htonl(L:longint):longint;
begin
  asm
     mov dx,word ptr [L]
     xchg dh,dl
     mov ax,word ptr [L]
     xchg ah,al
  end;
end;

{Convert Pascal word to network word order}
function Htons(W:word):word;
begin
  Htons := Swap(W);
end;

function Ntohl(L:longint):longint;
begin
  asm
     mov dx,word ptr [L]
     xchg dh,dl
     mov ax,word ptr [L]
     xchg ah,al
  end;
end;

function Ntohs(W:word):word;
begin
  Ntohs := Swap(W);
end;


{===================================================}
{Name Translation Services}


{---------------------------------------------------}
{GetHostByAddr returns a pointer to a structure describing the host}
{on error, returns null.}
{Possible Errors are: EIO, ENOBUFS, EPROTNOSUPPORT}
function GetHostByAddr(IPaddr:pointer; len,ta:integer):HostEntPtr;
var n : integer;
begin
   taddr[0] := longint(IPaddr);
   if ta <> AF_Inet then    {only type AF_Inet allowed}
   begin
     errno := EPROTOTYPE;
     GetHostByAddr := nil;
   end;

   n := AdResName(taddr[0], @buf, sizeof(buf));
   if n <> 0 then
   begin
     GetHostByAddr := nil;
   end
   else
   begin
     he.hName := @buf;
     he.hAliases := @hptr;
     hptr[0] := nil;
     he.hAddrType := AF_Inet;
     he.hLength := sizeof(longint);
     tptr[0] := @taddr[0];
     tptr[1] := nil;
     he.hAddrList := tptr[0];
     GetHostByAddr := @he;
   end;
end;

{---------------------------------------------------}
{GetHostByName returns a pointer to a structure describing the host}
{on error, returns null. On entry name points to host name}
{Possible Errors are: EIO, ENOBUFS, EPROTNOSUPPORT}
function GetHostByName(name:Pointer):HostEntPtr;
begin
   taddr[0] := NmResName(name, @buf, sizeof(buf));
   if taddr[0] = 0 then
   begin
     GetHostByName := nil;
   end
   else
   begin
     he.hName := @buf;
     he.hAliases := @hptr;
     hptr[0] := nil;
     he.hAddrType := AF_Inet;
     he.hLength := sizeof(longint);
     tptr[0] := @taddr[0];
     tptr[1] := nil;
     he.hAddrList := tptr[0];
     GetHostByName := @he;
   end;
end;



{===================================================}
{Protocol Entry Routines}

{ - none implemented - }

{===================================================}
{Service Entry Routines}

{ - none implemented - }

{===================================================}
{Internet Address Manipulation Routines}

{ - none implemented - }


{+++++++++++++++++++++++++++++++++++++++++++++++++++}
begin
   fillchar(he,sizeof(he),0);
   fillchar(buf,sizeof(buf),0);
   fillchar(hptr,sizeof(hptr),0);
   fillchar(taddr,sizeof(taddr),0);
   fillchar(tptr,sizeof(tptr),0);
   SocketInit := 0;
end.

